#!/usr/bin/env python
# -*- coding: utf-8 -*-

import argparse
import schnueffel.messages
import schnueffel.calculations as calc
import schnueffel.plot as plot
import schnueffel.pygame_plot as pg_plot

# Set parameters
# -------------------------------------------------------------------------
FILE_PATH		= "sampletrace100.txt"
CAN_ID			= 0x007
SOURCE_CH       = 1
DESTINATION_CH  = 2

# -------------------------------------------------------------------------


parser = argparse.ArgumentParser(description='Tool to analyse can traces')
parser.add_argument('infilepath')

#\TODO REMOVE THE BRACKETS IN PARENTHESES

# --- take file name from command line ---
# args=parser.parse_args()

# --- take file name from here ---
args=parser.parse_args( [FILE_PATH] )

print("Reading " + args.infilepath)
# change the limit in the line below to only read a certain amount of lines from the file, line_limit=1000)
message_list,schnueffel_config=schnueffel.messages.parse_message_file(args.infilepath)
print "Configuration: ",schnueffel_config


# --- print all messages 

#for m in message_list:
#   print m.to_string()




# --- calculate the delay from one channel to another (gateway latency)

delays=calc.message_delay_cross_channel(message_list, SOURCE_CH, DESTINATION_CH, CAN_ID)

#for d in delays:
#    print "%0.6f" %(d[0]), d[1].to_string(), d[2].to_string()

(count, median, avg, min, max)=calc.stats( [x[0] for x  in delays] )
print "(count, median, avg, min, max)",(count, median, avg, min, max)






# --- calculate the delay on the same channel (generator / gateway jitter)

#delays=calc.message_delay_same_channel(message_list, 2, 0x35)

#for d in delays:
#    print "%0.6f" %(d[0]), d[1].to_string(), d[2].to_string()

#(count, median, avg, min, max)=calc.stats( [x[0] for x  in delays] )sampletrace
#print "(count, median, avg, min, max)",(count, median, avg, min, max)





# --- plot a histogramm

plot.hist([x[0] for x  in delays],buckets=50,range=(0,0.01),facecolor='red')




# --- calculate bus load statistics

#bus_load=calc.calculate_bus_load(message_list,2)

#print "Bus load: load, busy_time, interval, msg1, msg2"
#for d in bus_load:
#    print "%0.6f %0.6f %0.6f" %(d[0],d[1],d[2]), d[3].to_string(), d[4].to_string()  

#(count, median, avg, min, max)=calc.stats( [x[0] for x  in bus_load] )
#print "(count, median, avg, min, max) of load",(count, median, avg, min, max)




# --- plot channel usage

channel_messages=calc.filter_channel(message_list,1)
#plot.channel_usage(channel_messages)
#pg_plot.channel_usage(channel_messages)


